select
    an.numero
    , an.nome
    , (select sp.descricao
        from sp_grupoanimalespecifico (current_date, (select re.cdtipogrupoanimal
                                                        from tipogrupoanimal re
                                                        where upper(re.descricao) like '%LOCAL%')
        , an.cdanimal) sp) as Grupo_Atual_Local
    , (select re1.nome from setor re1 where re1.cdsetor = an.cdsetor) as Setor_Atual
    , an.dtnascimento as data_nascimento
    , an.dtbaixa as data_baixa
    , an.dtdesmama as data_desmama
    , (case
        when an.dtdesmama is not null then ((an.dtdesmama - an.dtnascimento) || ' dias')
        else null end) as Idade_Desmama
    , an.dtaptidao as data_aptidao
    , (case
        when an.dtaptidao is not null then ((an.dtaptidao - an.dtnascimento)|| ' dias')
        else null end) as Idade_Aptidao
    , ptent.data as Primeira_Tentativa
    , (case
        when ptent.data is not null then ((ptent.data - an.dtnascimento)|| ' dias')
        else null end) as Idade_Primeira_Tentativa
    , ptentp.data as Primeira_Concepcao
    , (case
        when ptentp.data is not null then ((ptentp.data- an.dtnascimento) || ' dias')
        else null end) as Idade_Primeira_Concepcao
    , pp.data as Primeiro_Parto
    , (case
        when pp.cdreproducao is not null then ((pp.data - an.dtnascimento) || ' dias')
        else null end) as Idade_Primeira_Parto
from
    animal an
    left join reproducao ptent on ptent.cdreproducao =
        (select first 1 re2.cdreproducao
            from reproducao re2
            where re2.cdanimal = an.cdanimal
                and re2.cdtiporeproducao in (1,2,3)
            order by re2.data asc)
    left join reproducao pdigp on pdigp.cdreproducao =
        (select first 1 re2.cdreproducao
            from reproducao re2
            where re2.cdanimal = an.cdanimal
                and re2.cdtiporeproducao in (4)
            order by re2.data asc)
    left join reproducao ptentp on ptentp.cdreproducao =
        (select first 1 re2.cdreproducao
            from reproducao re2
            where re2.cdanimal = an.cdanimal
                and re2.cdtiporeproducao in (1,2,3)
                and re2.data < pdigp.data
            order by re2.data desc)
    left join reproducao pp on pp.cdreproducao =
        (select first 1 re2.cdreproducao
            from reproducao re2
            where re2.cdanimal = an.cdanimal
                and re2.cdtiporeproducao in (7)
            order by re2.data asc)
where
----ALTERAR O PERODO DE NASCIMENTO AQUI, CONFORME DESEJADO. MANTER O FORMATO DA DATA 'AAAA-MM-DD'.
    an.dtnascimento between '1900-01-01' and '2200-12-31'
order by an.numordenado
